<template>
  <div class="i3-container">
    <back></back>
    <h1 class="i3-page-title">Select a Content Type</h1>
    <div v-for="(name, key) in contentTypes" :key="key">
      <input type="radio" :id="key" :value="key" v-model="selectedContentType" @click="selectContentType(key)">
      <label :for="key">{{ name }}</label>
    </div>

    <button @click="pushNextPage()" class="i3-next" :disabled="!selectedContentType">Next</button>
    <!-- <li v-for="(name, key) in contentTypes" :key="key" @click="pushPage(nextComponent(key), { contentType: key }, 'New ' + name)">{{ name }}</li> -->

    <!-- <pre>{{ EDITABLE_NODE_PRESETS }}</pre> -->
    <!-- <li @click="pushPage('starting-point-category', {}, 'Starting Point')">Starting Point Category</li> -->
  </div>
</template>

<script>
import _ from 'lodash'

import { EDITABLE_NODE_PRESETS } from '@/components/Editable/config'

import { mapActions, mapGetters } from 'vuex'

import Back from '@/components/Editable/Utils/Back'

export default {
  components: {
    Back
  },

  props: {
    // timestamp: {
    //   type: Number,
    //   required: true
    // }
  },

  data () {
    return {
      selectedContentType: null,
      pushOnce: true
    }
  },

  computed: {
    ...mapGetters({
      backPageTitle: 'Y3TI/backPageTitle',
      contentTypes: 'Y3TI/contentTypes',
      routing: 'Y3TI/routing'
    }),

    nextPage () {
      // console.log('EDITABLE_NODE_PRESETS[key]', EDITABLE_NODE_PRESETS[key])
      return _.isEmpty(EDITABLE_NODE_PRESETS[this.selectedContentType]) ? { component: 'new-node-form-category', title: 'New ' + this.contentTypes[this.selectedContentType] } : { component: 'new-node-presets-category', props: { contentType: this.selectedContentType }, title: 'Select preset for new ' + this.contentTypes[this.selectedContentType] }
      // return 'new-node-form-category'
    }
  },

  methods: {
    ...mapActions({
      pushSidebarPage: 'Y3TI/pushSidebarPage',
      backSidebarPage: 'Y3TI/backSidebarPage',
      getContentTypes: 'Y3TI/getContentTypes'
    }),

    pushNextPage () {
      return this.pushSidebarPage({ data: { page: this.nextPage } })
    },

    backPage () {
      return this.backSidebarPage()
    },

    selectContentType (contentType) {
      // const layoutName = _.get(this.$route, [ 'matched', 0, 'components', 'default', 'name' ])
      // console.log('this.$route', this.$route)
      // this.$router.push({ name: 'NewNode-' + _.get(this.routing, ['definition', contentType, 'layout'], ''), params: { contentType, keepSidebar: true } })
      this.$router[this.pushOnce ? 'push' : 'replace']({ name: 'NewNode-' + _.get(this.routing, ['definition', contentType, 'layout'], ''), params: { contentType, keepSidebar: true }, hash: window.location.hash })
      this.pushOnce = false
    }
    // nextComponent (key) {
    //   // console.log('EDITABLE_NODE_PRESETS[key]', EDITABLE_NODE_PRESETS[key])
    //   // return _.isEmpty(EDITABLE_NODE_PRESETS[key]) ? 'new-node-form-category' : 'new-node-presets-category'
    //   return 'new-node-form-category'
    // }
  },

  created () {
    this.getContentTypes({ options: { lazy: true } })
    console.log('jjjjj')
  }
}
</script>

<style lang="scss" scoped>
</style>
